Attribute VB_Name = "Reg"

Option Explicit

Public Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" _
    (ByVal hKEY As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Public Declare Function RegCloseKey Lib "advapi32.dll" _
    (ByVal hKEY As Long) As Long
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" _
    (ByVal hKEY As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Public Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" _
    (ByVal hKEY As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Public Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" _
    (ByVal hKEY As Long, ByVal lpValueName As String) As Long
Public Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" _
    (ByVal hKEY As Long, ByVal lpSubKey As String) As Long

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003

Public Const ERROR_SUCCESS = 0&
Public Const KEY_QUERY_VALUE = &H1&
Public Const KEY_SET_VALUE = &H2&
Public Const KEY_CREATE_SUB_KEY = &H4&
Public Const KEY_ENUMERATE_SUB_KEYS = &H8&
Public Const KEY_NOTIFY = &H10&
Public Const READ_CONTROL = &H20000

Public Const STANDARD_RIGHTS_WRITE = READ_CONTROL
Public Const STANDARD_RIGHTS_READ = READ_CONTROL

Public Const KEY_READ = STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY
Public Const KEY_WRITE = STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY
Public Const REG_SZ = 1&

Dim lhKey As Long
Dim lRet As Long
Dim lBuffer As Long
Dim lBufferSize As Long
Dim sBuffer As String

Function GetString(LngMainKeyHandle As Long, SubKey As String, Entry As String) As String
    
    On Error Resume Next
    
    lRet = RegOpenKeyEx(LngMainKeyHandle, SubKey, 0, KEY_READ, lhKey)
    If lRet = ERROR_SUCCESS Then
        sBuffer = Space(255)
        lBufferSize = Len(sBuffer)
        lRet = RegQueryValueEx(lhKey, Entry, 0, REG_SZ, sBuffer, lBufferSize)
        If lRet = ERROR_SUCCESS Then
            Call RegCloseKey(lhKey)
            sBuffer = Trim(sBuffer)
            GetString = Left(sBuffer, Len(sBuffer) - 1)
        Else
            GetString = "ERROR"
        End If
    Else
        GetString = "ERROR"
    End If

End Function

Sub SetStringValue(LngMainKeyHandle As Long, SubKey As String, Entry As String, Value As String)
   
   On Error Resume Next
   
   Call RegOpenKeyEx(LngMainKeyHandle, SubKey, 0, KEY_WRITE, lhKey)
   Call RegSetValueEx(lhKey, Entry, 0, REG_SZ, ByVal Value, Len(Value))
   Call RegCloseKey(lhKey)

End Sub

Sub DeleteValue(LngMainKeyHandle As Long, Keyname As String, Entry As String)

    On Error Resume Next
    
    Call RegOpenKeyEx(LngMainKeyHandle, Keyname, 0, KEY_WRITE, lhKey)
    Call RegDeleteValue(lhKey, Entry)
    Call RegCloseKey(lhKey)

End Sub
